package dev.shadowsoffire.apotheosis.village.wanderer;

import net.minecraft.world.item.trading.MerchantOffer;
import net.minecraft.util.RandomSource;
import net.minecraft.world.entity.Entity;
import com.google.gson.JsonSerializationContext;
import com.google.gson.JsonParseException;
import com.google.gson.JsonObject;
import net.minecraft.world.item.ItemStack;
import com.google.gson.JsonDeserializationContext;
import java.lang.reflect.Type;
import com.google.gson.JsonElement;
import com.google.gson.JsonSerializer;
import net.minecraftforge.common.BasicItemListing;
import com.google.gson.JsonDeserializer;

public class BasicItemListingAdapter implements JsonDeserializer<BasicItemListing>, JsonSerializer<BasicItemListing>
{
    public static final BasicItemListingAdapter INSTANCE;
    
    @Override
    public BasicItemListing deserialize(final JsonElement json, final Type typeOfT, final JsonDeserializationContext ctx) throws JsonParseException {
        final JsonObject obj = json.getAsJsonObject();
        final ItemStack price1 = ctx.deserialize(obj.get("input_1"), ItemStack.class);
        final ItemStack price2 = obj.has("input_2") ? ctx.deserialize(obj.get("input_2"), ItemStack.class) : ItemStack.f_41583_;
        final ItemStack output = ctx.deserialize(obj.get("output"), ItemStack.class);
        final int maxTrades = obj.has("max_trades") ? obj.get("max_trades").getAsInt() : 1;
        final int xp = obj.has("xp") ? obj.get("xp").getAsInt() : 0;
        final float priceMult = obj.has("price_mult") ? obj.get("price_mult").getAsFloat() : 1.0f;
        return new BasicItemListing(price1, price2, output, maxTrades, xp, priceMult);
    }
    
    @Override
    public JsonElement serialize(final BasicItemListing src, final Type typeOfSrc, final JsonSerializationContext ctx) {
        final JsonObject obj = new JsonObject();
        final MerchantOffer offer = src.m_213663_((Entity)null, (RandomSource)null);
        obj.add("input_1", ctx.serialize(offer.m_45352_()));
        obj.add("input_2", ctx.serialize(offer.m_45364_()));
        obj.add("output", ctx.serialize(offer.m_45368_()));
        obj.addProperty("max_trades", offer.m_45373_());
        obj.addProperty("xp", offer.m_45379_());
        obj.addProperty("price_mult", offer.m_45378_());
        return obj;
    }
    
    static {
        INSTANCE = new BasicItemListingAdapter();
    }
}
